// Copyright (c) 1998-2024 by the citadel.org team
// This program is open source software.  Use, duplication, or disclosure is subject to the GNU General Public License v3.

struct citsmtp {		// Information about the current session
	int command_state;
	StrBuf *Cmd;
	StrBuf *helo_node;
	StrBuf *from;
	StrBuf *recipients;
	StrBuf *OneRcpt;
	int number_of_recipients;
	int delivery_mode;
	int message_originated_locally;
	int is_lmtp;
	int is_unfiltered;
	int is_msa;
	StrBuf *preferred_sender_email;
	StrBuf *preferred_sender_name;
};

#define SMTP		((struct citsmtp *)CC->session_specific_data)

// These are all the values that can be passed to the is_final parameter of smtp_do_bounce()
enum {
	SDB_BOUNCE_FATALS,
	SDB_BOUNCE_ALL,
	SDB_WARN
};

void smtp_do_bounce(const char *instr, int is_final);
char *smtpstatus(int code);
void dkim_sign(StrBuf *email, char *pkey_in, char *domain, char *selector);
void dkim_init(void);
void dkim_check_advisory(char *inetcfg_in);
EVP_PKEY *dkim_import_key(char *pkey_in);
char *dkim_get_public_key(EVP_PKEY *pkey);
